---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/21 8:20
---
---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/3 17:28
---
GW_StoryWindow = GW_StoryWindow or BaseClass(BaseView)

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_StoryWindow:__init()
    self.ctrl = GW_StoryController:getInstance()
    self.is_full_screen = true
    self.layout_name = "gw_story/gw_story_window"
    --self.win_type = WinType.Tips
    self.view_tag = ViewMgrTag.MSG_TAG

    self.res_list = {
        --{ path = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena"), type = ResourcesType.plist},
        --{ path = PathTool.getPlistImgForDownLoad("gw_drama/world","gw_drama_world_bg", true), type = ResourcesType.single },
    }

end

--关卡-剧情数据
function GW_StoryWindow:openRootWnd(story_id, is_reback)
    self.story_id = story_id
    self.is_reback = is_reback
    self.step_list = {}
    for i,v in pairs(Config.ScriptsData.data_drama[story_id].step) do
        table_insert(self.step_list, v)
    end
    --Debug.info(self.step_list)
    self.step_index = 1
    self.is_auto = false
    self.skip_second_sure_flag = false

    self:ShowStepEffect()
    self.skip_second_sure_panel:setVisible(false)
end

function GW_StoryWindow:open_callback()
    self.effect_node = self.root_wnd:getChildByName("effect_node")
    self.skip_second_sure_panel = self.root_wnd:getChildByName("skip_second_sure_panel")
    self.skip_second_sure_panel:setScale(display.getMaxScale())
    self.skip_second_sure_panel_cancel_btn = self.skip_second_sure_panel:getChildByName("cancel_btn")
    self.skip_second_sure_panel_cancel_btn:getChildByName("label"):setString(UI_TI18N(57001))
    self.skip_second_sure_panel_sure_btn = self.skip_second_sure_panel:getChildByName("sure_btn")
    self.skip_second_sure_panel_sure_btn:getChildByName("label"):setString(UI_TI18N(57002))

    self.tips_label = self.skip_second_sure_panel:getChildByName("tips_label")--
    self.tips_label:setString(string.format("--%s--", UI_TI18N(57003)))

    self.effect_node:setVisible(true)
end

function GW_StoryWindow:register_event()
    registerButtonEventListener(self.skip_second_sure_panel_cancel_btn, function()
        if self.skip_second_sure_flag == true then
            self.skip_second_sure_flag = false
            self.skip_second_sure_panel:setVisible(false)
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.skip_second_sure_panel, function()
        if self.skip_second_sure_flag == true then
            self.skip_second_sure_flag = false
            self.skip_second_sure_panel:setVisible(false)
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.skip_second_sure_panel_sure_btn, function()
        print("registerButtonEventListener(self.skip_second_sure_panel_sure_btn")
        print(self.skip_second_sure_flag)
        print(self.is_reback)
        if self.skip_second_sure_flag == true then
            if self.time_ticket ~= nil then
                GlobalTimeTicket:getInstance():remove(self.time_ticket)
                self.time_ticket = nil
            end
            self.skip_second_sure_flag = false
            if self.is_reback == true then
                self.ctrl:closeView()
            else
                local drama_data = {}
                drama_data.type = 0
                drama_data.args1 = 0
                drama_data.args2 = 0
                drama_data.args3 = 0
                self.ctrl:send_11132(self.story_id, self.step_list[self.step_index], drama_data)
            end
            if self.story_stage.resetStage then
                self.story_stage:resetStage()
            end
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
end

function GW_StoryWindow:close_callback()
    if self.story_stage then
        self.story_stage:DeleteMe()
    end
    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end

    self.ctrl:closeView()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_StoryWindow:__delete()
    Debug.log("GW_StoryWindow:__delete()")
end

function GW_StoryWindow:ShowStepEffect()
    self.effect_finished = false

    local event_config = Config.ScriptsData.data_event_fun(self.step_list[self.step_index])
    --local event_control_config = Config.ScriptsData.data_event_control_fun(event_config.event_control)
    --if event_control_config.type == GW_StoryConst.event_type.chat then
    --    self:showChatEffect(event_config)
    --end
    self:showStoryStage(event_config)
    local effect_config = self.story_stage:getCurrentEffectCoifig()

    self.time_ticket_count = 0
    --self.time_ticket_count = 1
    self.time_event = 5--默认自动处理事件时间
    self.time_event_max = 20
    if effect_config and effect_config.duration > 0 then
        self.time_event = effect_config.duration + 1
        --self.time_event_max = self.time_event + 15
    end
    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end
    self.time_ticket = GlobalTimeTicket:getInstance():add(function()
        self.time_ticket_count = self.time_ticket_count + 1
        Debug.info(self.time_ticket_count)
        --if self.skip_second_sure_flag == false then
            if self.is_auto == true then
                if self.time_ticket_count >= self.time_event then
                    if self.time_ticket ~= nil then
                        GlobalTimeTicket:getInstance():remove(self.time_ticket)
                        self.time_ticket = nil
                    end
                    self.step_index = self.step_index + 1
                    if self.step_index > #self.step_list then
                        if self.is_reback == true then
                            self.ctrl:closeView()
                        else
                            self.ctrl:send_11131(self.story_id)
                        end
                    else
                        self:ShowStepEffect()
                    end
                end
            else
                if self.time_ticket_count >= self.time_event_max then
                    if self.time_ticket ~= nil then
                        GlobalTimeTicket:getInstance():remove(self.time_ticket)
                        self.time_ticket = nil
                    end
                    self.step_index = self.step_index + 1
                    if self.step_index > #self.step_list then
                        if self.is_reback == true then
                            self.ctrl:closeView()
                        else
                            self.ctrl:send_11131(self.story_id)
                        end
                    else
                        self:ShowStepEffect()
                    end
                end
            end
        --end
    end, 1)
end
--function GW_StoryWindow:showChatEffect(event_config)
--    if not self.chat_effect then
--        self.chat_effect = GW_StoryWindowChatEffect.new()
--        self.chat_effect:addAutoCallBack(handler(self,self.onClickChatEffectAutoBtn))
--        self.chat_effect:addCancelAutoCallBack(handler(self,self.onClickChatEffectCancelAutoBtn))
--        self.chat_effect:addNextCallBack(handler(self,self.onClickChatEffectNextBtn))
--        self.chat_effect:addSkipCallBack(handler(self,self.onClickChatEffectSkipBtn))
--        self.chat_effect:addFinishCallBack(handler(self,self.onChatEffectFinish))
--        self.effect_node:addChild(self.chat_effect)
--    end
--
--    self.chat_effect:setData(self.step_index, event_config, self.is_auto)
--    self.chat_effect:setVisible(true)
--end
function GW_StoryWindow:showStoryStage(event_config)
    if not self.story_stage then
        self.story_stage = WY_StoryWindowStage.new()
        self.story_stage:addAutoCallBack(handler(self,self.onClickAutoBtn))
        self.story_stage:addCancelAutoCallBack(handler(self,self.onClickCancelAutoBtn))
        self.story_stage:addNextCallBack(handler(self,self.onClickNextBtn))
        self.story_stage:addSkipCallBack(handler(self,self.onClickSkipBtn))
        self.story_stage:addFinishCallBack(handler(self,self.onStoryFinish))
        self.effect_node:addChild(self.story_stage)
    end

    self.story_stage:setData(self.step_index, event_config, self.is_auto)
    self.story_stage:setVisible(true)
end
function GW_StoryWindow:onClickAutoBtn()
    --local event_config = Config.ScriptsData.data_event_fun(self.step_list[self.step_index])
    --local event_control_config = Config.ScriptsData.data_event_control_fun(event_config.event_control)
    --if event_control_config.type ~= GW_StoryConst.event_type.chat then
    --    return
    --end

    if self.is_auto == true then
        return
    end

    self.is_auto = true
    if self.story_stage then
        self.story_stage:setAutoStatu(self.is_auto)
    end
end
function GW_StoryWindow:onClickCancelAutoBtn()
    --local event_config = Config.ScriptsData.data_event_fun(self.step_list[self.step_index])
    --local event_control_config = Config.ScriptsData.data_event_control_fun(event_config.event_control)
    --if event_control_config.type ~= GW_StoryConst.event_type.chat then
    --    return
    --end

    if self.is_auto == false then
        return
    end

    self.is_auto = false
    if self.story_stage then
        self.story_stage:setAutoStatu(self.is_auto)
    end
end
function GW_StoryWindow:onClickNextBtn()
    Debug.info("onClickNextBtn self.time_ticket_count = " .. self.time_ticket_count)
    if self.time_ticket_count < 1 then
        return
    end

    --local event_config = Config.ScriptsData.data_event_fun(self.step_list[self.step_index])
    --local event_control_config = Config.ScriptsData.data_event_control_fun(event_config.event_control)
    --if event_control_config.type ~= GW_StoryConst.event_type.chat then
    --    return
    --end

    --if not self.effect_finished or self.effect_finished == false then
    --    return
    --end

    self.step_index = self.step_index + 1
    if self.step_index > #self.step_list then
        if self.time_ticket ~= nil then
            GlobalTimeTicket:getInstance():remove(self.time_ticket)
            self.time_ticket = nil
        end
        if self.is_reback == true then
            self.ctrl:closeView()
        else
            self.ctrl:send_11131(self.story_id)
        end
    else
        self:ShowStepEffect()
    end
end
function GW_StoryWindow:onClickSkipBtn()
    if self.time_ticket_count < 1 then
        Debug.info("onClickSkipBtn self.time_ticket_count = " .. self.time_ticket_count)
        return
    end

    --local event_config = Config.ScriptsData.data_event_fun(self.step_list[self.step_index])
    --local event_control_config = Config.ScriptsData.data_event_control_fun(event_config.event_control)
    --if event_control_config.type ~= GW_StoryConst.event_type.chat then
    --    return
    --end

    if self.skip_second_sure_flag == false then
        self.skip_second_sure_flag = true
        self.skip_second_sure_panel:setVisible(true)
    end
end
function GW_StoryWindow:onStoryFinish()
    --local event_config = Config.ScriptsData.data_event_fun(self.step_list[self.step_index])
    --local event_control_config = Config.ScriptsData.data_event_control_fun(event_config.event_control)
    --if event_control_config.type ~= GW_StoryConst.event_type.chat then
    --    return
    --end

    self.effect_finished = true
end
