---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/21 8:21
---
-- --------------------------------------------------------------------
-- 故事舞台
-- --------------------------------------------------------------------
WY_StoryWindowStage = class("WY_StoryWindowStage", function()
    return ccui.Widget:create()
end)

function WY_StoryWindowStage:ctor()
    self:config()
    self:layoutUI()
    self:registerEvents()
end
function WY_StoryWindowStage:config()
    self.size = cc.size(1280,720)
    self:setContentSize(self.size)
    self:setScale(1)
    self.fadeInTime = 0.3
    self.word_delay_time = 0.05--对话框文字控制速度,越大越慢
    self.color_grey = cc.c3b(90, 90, 90)
end
function WY_StoryWindowStage:layoutUI()
    local csbPath = PathTool.getTargetCSB("gw_story/wy_story_window_stage")
    self.root_wnd = cc.CSLoader:createNode(csbPath)
    self:addChild(self.root_wnd)

    --self.root_wnd:setAnchorPoint(cc.p(0.5, 0.5))
    --self.root_wnd:setPosition(SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2)

    self.next_btn = self.root_wnd:getChildByName("next_btn")
    self.next_btn:setLocalZOrder(GW_StoryConst.z_order.ui)
    self.next_btn:setPositionY(display.getBottom() + 120)
    self.auto_btn = self.root_wnd:getChildByName("auto_btn")
    self.auto_btn:setLocalZOrder(GW_StoryConst.z_order.ui)
    self.auto_btn:setPositionX(display.getRight() - 280)
    self.cancel_auto_btn = self.root_wnd:getChildByName("cancel_auto_btn")
    self.cancel_auto_btn:setLocalZOrder(GW_StoryConst.z_order.ui)
    self.cancel_auto_btn:setPositionX(display.getRight() - 280)
    self.skip_btn = self.root_wnd:getChildByName("skip_btn")
    self.skip_btn:setLocalZOrder(GW_StoryConst.z_order.ui)
    self.skip_btn:setPositionX(display.getRight() - 110)

    self.effect_node = self.root_wnd:getChildByName("effect_node")
    self.effect_node:setLocalZOrder(GW_StoryConst.z_order.effect)

    self.next_btn:setVisible(false)
    self.skip_btn:setVisible(false)
    self.auto_btn:setVisible(false)
    self.cancel_auto_btn:setVisible(false)

    self.background = self.root_wnd:getChildByName("background")
    self.background:setVisible(false)
    self.left_npc_node = self.root_wnd:getChildByName("left_npc_node")
    self.left_npc_node.isShow = false
    self.left_npc_node:setVisible(false)
    self.center_npc_node = self.root_wnd:getChildByName("center_npc_node")
    self.center_npc_node.isShow = false
    self.center_npc_node:setVisible(false)
    self.right_npc_node = self.root_wnd:getChildByName("right_npc_node")
    self.right_npc_node.isShow = false
    self.right_npc_node:setVisible(false)

    self.content_type1 = self.root_wnd:getChildByName("content_type1")
    self.content_type1:setLocalZOrder(GW_StoryConst.z_order.ui - 1)
    self.content_type1:setPositionY(display.getBottom())
    self.content_type1:setVisible(false)
    self.content_type2 = self.root_wnd:getChildByName("content_type2")
    self.content_type2:setLocalZOrder(GW_StoryConst.z_order.ui - 1)
    self.content_type2:setPositionY(display.getBottom())
    self.content_type2:setVisible(false)
    self.content_type3 = self.root_wnd:getChildByName("content_type3")
    self.content_type3:setLocalZOrder(GW_StoryConst.z_order.ui - 1)
    self.content_type3:setPositionY(display.getBottom())
    self.content_type3:setVisible(false)
    self.content_type4 = self.root_wnd:getChildByName("content_type4")
    self.content_type4:setLocalZOrder(GW_StoryConst.z_order.ui - 1)
    self.content_type4:setScale(display.getMaxScale())
    self.content_type4:setVisible(false)

    self.story_effect = WY_StoryWindowEffect.new(self)
    self.effect_node:addChild(self.story_effect)

end
function WY_StoryWindowStage:registerEvents()
    registerButtonEventListener(self.next_btn, function()
        if self.content_type1:isVisible() and self.content_type1.is_working then
            self.content_type1_rich_label:setString(self.content_type1_rich_label.word)
            self.content_type1:stopAllActions()
            self.content_type1.is_working = false
            return
        end
        if self.content_type2:isVisible() and self.content_type2.is_working then
            self.content_type2_rich_label:setString(self.content_type2_rich_label.word)
            self.content_type2:stopAllActions()
            self.content_type2.is_working = false
            return
        end
        if self.content_type3:isVisible() and self.content_type3.is_working then
            self.content_type3_rich_label:setString(self.content_type3_rich_label.word)
            self.content_type3:stopAllActions()
            self.content_type3.is_working = false
            return
        end
        if self.content_type4:isVisible() and self.content_type4.is_working then
            self.content_type4_rich_label:setString(self.content_type4_rich_label.word)
            self.content_type4:stopAllActions()
            self.content_type4.is_working = false
            return
        end

        --self.story_effect:stopAllActions()

        if self.next_callback then
            self:next_callback()
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.auto_btn, function()
        if self.auto_callback then
            self:auto_callback()
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.cancel_auto_btn, function()
        if self.auto_callback then
            self:cancel_auto_callback()
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.skip_btn, function()
        --self:resetStage()
        if self.skip_callback then
            self:skip_callback()
        end
    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

end
function WY_StoryWindowStage:DeleteMe()
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    if self.left_npc_draw_load then
        self.left_npc_draw_load:DeleteMe()
        self.left_npc_draw_load = nil
    end
    if self.center_npc_draw_load then
        self.center_npc_draw_load:DeleteMe()
        self.center_npc_draw_load = nil
    end
    if self.right_npc_draw_load then
        self.right_npc_draw_load:DeleteMe()
        self.right_npc_draw_load = nil
    end
end
function WY_StoryWindowStage:setData(step_index, event_config, is_auto)
    Debug.info(step_index)
    self.step_index = step_index
    self.event_config = event_config
    self:setAutoStatu(is_auto)

    self.next_btn:setVisible(false)
    self.skip_btn:setVisible(true)
    --self.auto_btn:setVisible(false)
    --self.cancel_auto_btn:setVisible(false)
    --self.background:setVisible(false)
    --self.left_npc_node:setVisible(false)
    --self.center_npc_node:setVisible(false)
    --self.right_npc_node:setVisible(false)
    --self.content_type1:setVisible(false)
    --self.content_type2:setVisible(false)
    --self.content_type3:setVisible(false)
    --self.content_type4:setVisible(false)
    self:resetStage()

    --self:updateDialogContent(event_config)

    self.background_load_finished = false
    self.left_npc_load_finished = false
    self.center_npc_load_finished = false
    self.right_npc_load_finished = false


    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    if self.background_load_res == nil or self.background_load_res ~= event_config.background then
        Debug.info("场景背景淡出")
        --先淡出，加载完纹理再淡入
        --local bgAction = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
        --    local res = PathTool.getTargetRes("gw_story/background",event_config.background,false,true)
        --    self.background_load = loadImageTextureFromCDN(self.background, res, ResourcesType.single, self.background_load,nil, function(sender, event_type)
        --        if self.background_load then
        --            self.background_load:DeleteMe()
        --            self.background_load = nil
        --        end
        --
        --        --local res_size = self.background:getContentSize()
        --        --local scaleX, scaleY = res_size.width / display.width, res_size.height / display.height
        --        --local min_scale = math.min(scaleX, scaleY)
        --        --self.background:setScale(1 / min_scale)
        --        self.background:setScale(display.getMaxScale())
        --
        --        self.background_load_res = event_config.background
        --        --加载完纹理再淡入
        --        local bg_loading_action = cc.Sequence:create(cc.DelayTime:create(self.fadeInTime), cc.FadeIn:create(self.fadeInTime), cc.CallFunc:create(function()
        --            self.background_load_finished = true
        --            --self:checkShowFinished(1)
        --            self:updateNPCView(event_config)
        --        end))
        --        self.background:runAction(bg_loading_action)
        --
        --    end)
        --
        --end))
        --self.background:runAction(bgAction)

        --换场景应该先处理角色退场
        self:performNPCExit(function()
            local bgAction = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
                local res = PathTool.getTargetRes("gw_story/background",event_config.background,false,true)
                self.background_load = loadImageTextureFromCDN(self.background, res, ResourcesType.single, self.background_load,nil, function(sender, event_type)
                    if self.background_load then
                        self.background_load:DeleteMe()
                        self.background_load = nil
                    end

                    --local res_size = self.background:getContentSize()
                    --local scaleX, scaleY = res_size.width / display.width, res_size.height / display.height
                    --local min_scale = math.min(scaleX, scaleY)
                    --self.background:setScale(1 / min_scale)
                    self.background:setScale(display.getMaxScale())

                    self.background_load_res = event_config.background
                    --加载完纹理再淡入
                    local bg_loading_action = cc.Sequence:create(cc.DelayTime:create(self.fadeInTime), cc.FadeIn:create(self.fadeInTime), cc.CallFunc:create(function()
                        self.background_load_finished = true
                        --self:checkShowFinished(1)
                        self:updateNPCView(event_config)
                    end))
                    self.background:runAction(bg_loading_action)

                end)

            end))
            self.background:runAction(bgAction)
        end)
    else
        self:updateNPCView(event_config)
        self.background:stopAllActions()
        self.background:setOpacity(255)
        self.background_load_finished = true
        --self:checkShowFinished(1)
    end
    self.background:setVisible(true)

end
--更新左、中、右NPC对话
function WY_StoryWindowStage:updateNPCView(event_config)
    dump(event_config, "event_config = ", 8)
    self:beforeNPCUpdate(event_config)

    if self.left_npc_draw_load then
        self.left_npc_draw_load:DeleteMe()
        self.left_npc_draw_load = nil
    end
    if event_config.left_npc > 0 then
        local left_npc_config = Config.ScriptsData.data_npc_figure_fun(event_config.left_npc)
        if left_npc_config and left_npc_config.file_name then
            if not self.left_npc_draw then
                self.left_npc_draw = createSprite(nil, 0, 0, self.left_npc_node, cc.p(0.5, 0.5), LOADTEXT_TYPE)
            end
            self.left_npc_draw.npc_node = self.left_npc_node

            local draw_res = left_npc_config.file_name
            local draw_offset = left_npc_config.coordinate
            local draw_scale = left_npc_config.scale
            if not draw_offset or #draw_offset < 1  then
                draw_offset = {0,0}
            end
            if not draw_scale or #draw_scale < 1  then
                draw_scale = {1000,1000}
            end

            if not self.left_npc_draw_res or self.left_npc_draw_res ~= left_npc_config.file_name then
                local res = PathTool.getPlistImgForDownLoad("herodraw/herodrawres",draw_res, false)
                self.left_npc_draw_load = loadSpriteTextureFromCDN(self.left_npc_draw, res, ResourcesType.single, self.left_npc_draw_load, nil,function(sender, event_type)
                    if self.left_npc_draw_load then
                        self.left_npc_draw_load:DeleteMe()
                        self.left_npc_draw_load = nil
                    end


                    --淡入效果
                    self.left_npc_node:stopAllActions()
                    self.left_npc_node:setOpacity(0)
                    local act = cc.Sequence:create(cc.DelayTime:create(self.fadeInTime), cc.FadeIn:create(self.fadeInTime), cc.CallFunc:create(function()
                        self.left_npc_node.isShow = true
                        self.left_npc_draw_res = left_npc_config.file_name
                        self.left_npc_load_finished = true
                        self:checkShowFinished(2)
                        --setChildDarkShader(event_config.left_npc ~= event_config.speak_npc, self.left_npc_draw)
                        --self:finishEnterNPC()
                    end))

                    self:updateNPCStatus(event_config.left_npc == event_config.speak_npc, self.left_npc_draw)
                    self.left_npc_node:runAction(act)


                end)
            else
                self.left_npc_node.isShow = true
                --self.left_npc_load_finished = true
                --self:checkShowFinished(2)
                --setChildDarkShader(event_config.left_npc ~= event_config.speak_npc, self.left_npc_draw)
                self:updateNPCStatus(event_config.left_npc == event_config.speak_npc, self.left_npc_draw)
                --self:finishEnterNPC()
                if self.left_npc_node:getOpacity() < 1 then
                    self:performNPCEnter(self.left_npc_node)
                else
                    self.left_npc_load_finished = true
                    self:checkShowFinished(2)
                end
            end

            self.left_npc_draw:setPosition(draw_offset[1], draw_offset[2])
            self.left_npc_draw:setScaleX(draw_scale[1]/1000)
            self.left_npc_draw:setScaleY(draw_scale[2]/1000)

            self.left_npc_node:setVisible(true)
        else
            self.left_npc_node:setVisible(false)
            self.left_npc_load_finished = true
            --self:finishEnterNPC()
            self:checkShowFinished(2)
        end
    else
        if self.left_npc_node.isShow then
            --淡出效果
            self.left_npc_node.isShow = false
            --setChildDarkShader(false, self.left_npc_draw)
            self:updateNPCStatus(true, self.left_npc_draw)
            self.left_npc_node:stopAllActions()
            self.left_npc_node:setOpacity(255)
            local act = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
                self.left_npc_load_finished = true
                self:checkShowFinished(2)
                --self:finishExitNPC()
            end))
            self.left_npc_node:runAction(act)
        else
            self.left_npc_node:setVisible(false)
            self.left_npc_load_finished = true
            self:checkShowFinished(2)
        end
        self.left_npc_draw_res = nil
    end

    if event_config.mid_npc > 0 then
        local center_npc_config = Config.ScriptsData.data_npc_figure_fun(event_config.mid_npc)
        if center_npc_config and center_npc_config.file_name then
            if not self.center_npc_draw then
                self.center_npc_draw = createSprite(nil, 0, 0, self.center_npc_node, cc.p(0.5, 0.5), LOADTEXT_TYPE)
            end
            self.center_npc_draw.npc_node = self.center_npc_node

            local draw_res = center_npc_config.file_name
            local draw_offset = center_npc_config.coordinate
            local draw_scale = center_npc_config.scale
            if not draw_offset or #draw_offset < 1  then
                draw_offset = {0,0}
            end
            if not draw_scale or #draw_scale < 1  then
                draw_scale = {1000,1000}
            end

            if not self.center_npc_draw_res or self.center_npc_draw_res ~= center_npc_config.file_name then
                if self.center_npc_draw_load then
                    self.center_npc_draw_load:DeleteMe()
                    self.center_npc_draw_load = nil
                end
                self.center_npc_draw_res = center_npc_config.file_name

                local res = PathTool.getPlistImgForDownLoad("herodraw/herodrawres",draw_res, false)
                self.center_npc_draw_load = loadSpriteTextureFromCDN(self.center_npc_draw, res, ResourcesType.single, self.center_npc_draw_load, nil,function(sender, event_type)
                    if self.center_npc_draw_load then
                        self.center_npc_draw_load:DeleteMe()
                        self.center_npc_draw_load = nil
                    end


                    --淡入效果
                    self.center_npc_node:stopAllActions()
                    self.center_npc_node:setOpacity(0)
                    local act = cc.Sequence:create(cc.DelayTime:create(self.fadeInTime), cc.FadeIn:create(self.fadeInTime), cc.CallFunc:create(function()
                        self.center_npc_node.isShow = true
                        self.center_npc_load_finished = true
                        self:checkShowFinished(3)
                        --Debug.log("-------------------------------------------")
                        --Debug.log("-------------------------------------------")
                        --Debug.log("-------------------------------------------")
                        --Debug.info(self.center_npc_draw:getColor())
                        ----setChildDarkShader(event_config.mid_npc ~= event_config.speak_npc, self.center_npc_draw)
                        --Debug.info(self.center_npc_draw:getColor())
                        --self.center_npc_draw:setColor(cc.WHITE)
                        --Debug.log("-------------------------------------------")
                        --Debug.log("-------------------------------------------")
                        --Debug.log("-------------------------------------------")
                        --self:finishEnterNPC()
                    end))

                    self:updateNPCStatus(event_config.mid_npc == event_config.speak_npc, self.center_npc_draw)
                    self.center_npc_node:runAction(act)

                end)
            else
                self.center_npc_node.isShow = true
                --self.center_npc_load_finished = true
                --self:checkShowFinished(3)
                --setChildDarkShader(event_config.mid_npc ~= event_config.speak_npc, self.center_npc_draw)
                self:updateNPCStatus(event_config.mid_npc == event_config.speak_npc, self.center_npc_draw)
                --if self.center_npc_draw_load == nil then
                --    self.center_npc_load_finished = true
                --    self:checkShowFinished()
                --    setChildDarkShader(event_config.mid_npc ~= event_config.speak_npc, self.center_npc_draw)
                --end
                --self:finishEnterNPC()
                if self.center_npc_node:getOpacity() < 1 then
                    self:performNPCEnter(self.center_npc_node)
                else
                    self.center_npc_load_finished = true
                    self:checkShowFinished(3)
                end
            end

            self.center_npc_draw:setPosition(draw_offset[1], draw_offset[2])
            self.center_npc_draw:setScaleX(draw_scale[1]/1000)
            self.center_npc_draw:setScaleY(draw_scale[2]/1000)

            self.center_npc_node:setVisible(true)
        else
            self.center_npc_node:setVisible(false)
            self.center_npc_load_finished = true
            self:checkShowFinished(3)
            --self:finishEnterNPC()
        end
    else
        if self.center_npc_node.isShow then
            --淡出效果
            self.center_npc_node.isShow = false
            --setChildDarkShader(false, self.center_npc_draw)
            self:updateNPCStatus(true, self.center_npc_draw)
            self.center_npc_node:stopAllActions()
            self.center_npc_node:setOpacity(255)
            local act = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
                self.center_npc_load_finished = true
                self:checkShowFinished(3)
                --self:finishExitNPC()
            end))
            self.center_npc_node:runAction(act)
        else
            self.center_npc_node:setVisible(false)
            self.center_npc_load_finished = true
            self:checkShowFinished(3)
        end
        self.center_npc_draw_res = nil
    end


    if self.right_npc_draw_load then
        self.right_npc_draw_load:DeleteMe()
        self.right_npc_draw_load = nil
    end
    if event_config.right_npc > 0 then
        local right_npc_config = Config.ScriptsData.data_npc_figure_fun(event_config.right_npc)
        if right_npc_config and right_npc_config.file_name then
            if not self.right_npc_draw then
                self.right_npc_draw = createSprite(nil, 0, 0, self.right_npc_node, cc.p(0.5, 0.5), LOADTEXT_TYPE)
            end
            self.right_npc_draw.npc_node = self.right_npc_node

            local draw_res = right_npc_config.file_name
            local draw_offset = right_npc_config.coordinate
            local draw_scale = right_npc_config.scale
            if not draw_offset or #draw_offset < 1  then
                draw_offset = {0,0}
            end
            if not draw_scale or #draw_scale < 1  then
                draw_scale = {1000,1000}
            end

            if not self.right_npc_draw_res or self.right_npc_draw_res ~= right_npc_config.file_name then
                local res = PathTool.getPlistImgForDownLoad("herodraw/herodrawres",draw_res, false)
                self.right_npc_draw_load = loadSpriteTextureFromCDN(self.right_npc_draw, res, ResourcesType.single, self.right_npc_draw_load, nil,function(sender, event_type)
                    if self.right_npc_draw_load then
                        self.right_npc_draw_load:DeleteMe()
                        self.right_npc_draw_load = nil
                    end


                    --淡入效果
                    self.right_npc_node:stopAllActions()
                    self.right_npc_node:setOpacity(0)
                    local act = cc.Sequence:create(cc.DelayTime:create(self.fadeInTime), cc.FadeIn:create(self.fadeInTime), cc.CallFunc:create(function()
                        self.right_npc_node.isShow = true
                        self.right_npc_draw_res = right_npc_config.file_name
                        self.right_npc_load_finished = true
                        self:checkShowFinished(4)
                        --setChildDarkShader(event_config.right_npc ~= event_config.speak_npc, self.right_npc_draw)
                        --self:finishEnterNPC()
                    end))

                    self:updateNPCStatus(event_config.right_npc == event_config.speak_npc, self.right_npc_draw)
                    self.right_npc_node:runAction(act)

                end)
            else
                self.right_npc_node.isShow = true
                --self.right_npc_load_finished = true
                self:checkShowFinished(4)
                self:updateNPCStatus(event_config.right_npc == event_config.speak_npc, self.right_npc_draw)
                --setChildDarkShader(event_config.right_npc ~= event_config.speak_npc, self.right_npc_draw)
                --self:finishEnterNPC()
                if self.right_npc_node:getOpacity() < 1 then
                    self:performNPCEnter(self.right_npc_node)
                else
                    self.right_npc_load_finished = true
                    self:checkShowFinished(4)
                end
            end

            self.right_npc_draw:setPosition(draw_offset[1], draw_offset[2])
            self.right_npc_draw:setScaleX(draw_scale[1]/1000)
            self.right_npc_draw:setScaleY(draw_scale[2]/1000)

            self.right_npc_node:setVisible(true)
        else
            self.right_npc_node:setVisible(false)
            self.right_npc_load_finished = true
            self:checkShowFinished(4)
            --self:finishEnterNPC()
        end
    else
        if self.right_npc_node.isShow then
            --淡出效果
            self.right_npc_node.isShow = false
            --setChildDarkShader(false, self.right_npc_draw)
            self:updateNPCStatus(true, self.right_npc_draw)
            self.right_npc_node:stopAllActions()
            self.right_npc_node:setOpacity(255)
            local act = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
                self.right_npc_load_finished = true
                self:checkShowFinished(4)
                --self:finishExitNPC()
            end))
            self.right_npc_node:runAction(act)
        else
            self.right_npc_node:setVisible(false)
            self.right_npc_load_finished = true
            self:checkShowFinished(4)
        end
        self.right_npc_draw_res = nil
    end
end

function WY_StoryWindowStage:addAutoCallBack(callback)
    self.auto_callback = callback
end
function WY_StoryWindowStage:addCancelAutoCallBack(callback)
    self.cancel_auto_callback = callback
end
function WY_StoryWindowStage:addSkipCallBack(callback)
    self.skip_callback = callback
end
function WY_StoryWindowStage:addNextCallBack(callback)
    self.next_callback = callback
end
function WY_StoryWindowStage:setAutoStatu(is_auto)
    if is_auto == true then
        self.auto_btn:setVisible(false)
        self.cancel_auto_btn:setVisible(true)
    else
        self.auto_btn:setVisible(true)
        self.cancel_auto_btn:setVisible(false)
    end
end
function WY_StoryWindowStage:addFinishCallBack(callback)
    self.finish_callback = callback
end

function WY_StoryWindowStage:checkShowFinished(index)
    --if self.background_load_finished == false then
    --    return
    --end
    if self.left_npc_load_finished == false then
        return
    end
    if self.center_npc_load_finished == false then
        return
    end
    if self.right_npc_load_finished == false then
        return
    end
    --
    --if self.finish_callback then
    --    self.finish_callback()
    --end
    --if index then
    --    Debug.log("checkShowFinished = " .. index)
    --end
    --Debug.log("加载完成后播放的特效")
    local effect_config = self:getCurrentEffectCoifig()
    if effect_config then
        if GW_StoryConst.effect_playing_type.delay == effect_config.play_time then
            --加载完成后播放的特效
            --Debug.log("effect_config.play_time = " .. effect_config.play_time)
            Debug.log("加载完成后播放的特效")
            self.story_effect:playingStoryEffect(effect_config, true)
        end
    else
        self.next_btn:setVisible(true)
    end
    --self:runAction(cc.Sequence:create(cc.DelayTime:create(0.2), cc.CallFunc:create(function()
    --    self:updateDialogContent(self.event_config)
    --end)))
    self:updateDialogContent(self.event_config)--打字机
end

function WY_StoryWindowStage:dialogLabelAnimate(dialogLabel)
    local isGonOn = true
    dialogLabel.current_len = dialogLabel.current_len + 3
    local word_len = string.len(dialogLabel.word)
    if dialogLabel.current_len >= word_len then
        dialogLabel.current_len = word_len
        isGonOn = false
    end
    local new_word = string.sub(dialogLabel.word,1, dialogLabel.current_len)
    --Debug.log(dialogLabel.word)
    --Debug.log(new_word)
    dialogLabel:setString(new_word)
    return isGonOn
end

function WY_StoryWindowStage:updateContentType1(event_config)
    if event_config.diag_type == GW_StoryConst.chat_event_diag_type.npc then
        if self.content_type1_rich_label == nil then
            self.content_type1_name = self.content_type1:getChildByName("name_bg"):getChildByName("name")
            local content_container = self.content_type1:getChildByName("content_container")
            local size = content_container:getContentSize()
            self.content_type1_rich_label = createRichLabel(28, cc.c4b(0x46,0x46,0x46,0xff), cc.p(0,1), cc.p(0 ,size.height), -5, 1, size.width)
            content_container:addChild(self.content_type1_rich_label)
        end

        if event_config.speak_npc > 0 then
            local npc_config = Config.ScriptsData.data_npc_figure_fun(event_config.speak_npc)

            --self.content_type1_name:setString(npc_config.name)
            StringUtil.gw_setRoleNickName2(self.content_type1_name, npc_config.name, 230)
        end
        --self.content_type1_rich_label:setString(event_config.word)
        self.content_type1_rich_label:setString("")

        self.content_type1:setVisible(true)

        self.content_type1_rich_label.word = event_config.word
        self.content_type1_rich_label.current_len = 0
        self.content_type1.is_working = true
        local act = cc.RepeatForever:create(cc.Sequence:create(cc.CallFunc:create(function()
            local isGoOn = self:dialogLabelAnimate(self.content_type1_rich_label)
            if not isGoOn then
                self.content_type1:stopAllActions()
                self.content_type1.is_working = false
            end
        end), cc.DelayTime:create(self.word_delay_time)))
        self.content_type1:runAction(act)
    else
        self.content_type1:setVisible(false)
    end
end
function WY_StoryWindowStage:updateContentType2(event_config)
    if event_config.diag_type == GW_StoryConst.chat_event_diag_type.role then
        if self.content_type2_rich_label == nil then
            self.content_type2_name = self.content_type2:getChildByName("name_bg"):getChildByName("name")
            local content_container = self.content_type2:getChildByName("content_container")
            local size = content_container:getContentSize()
            self.content_type2_rich_label = createRichLabel(28, cc.c4b(0x46,0x46,0x46,0xff), cc.p(0,1), cc.p(0 ,size.height), -5, 1, size.width)
            content_container:addChild(self.content_type2_rich_label)
        end

        local role_vo = RoleController:getInstance():getRoleVo()
        --self.content_type2_name:setString(role_vo.name)
        StringUtil.gw_setRoleNickName2(self.content_type2_name, role_vo.name, 230)
        --self.content_type2_rich_label:setString(event_config.word)
        self.content_type2_rich_label:setString("")

        self.content_type2:setVisible(true)

        self.content_type2_rich_label.word = event_config.word
        self.content_type2_rich_label.current_len = 0
        self.content_type2.is_working = true
        local act = cc.RepeatForever:create(cc.Sequence:create(cc.CallFunc:create(function()
            local isGoOn = self:dialogLabelAnimate(self.content_type2_rich_label)
            if not isGoOn then
                self.content_type2:stopAllActions()
                self.content_type2.is_working = false
            end
        end), cc.DelayTime:create(self.word_delay_time)))
        self.content_type2:runAction(act)
    else
        self.content_type2:setVisible(false)
    end
end
function WY_StoryWindowStage:updateContentType3(event_config)
    if event_config.diag_type == GW_StoryConst.chat_event_diag_type.aside then
        if self.content_type3_rich_label == nil then
            local content_container = self.content_type3:getChildByName("content_container")
            local size = content_container:getContentSize()
            self.content_type3_rich_label = createRichLabel(28, cc.c4b(0x46,0x46,0x46,0xff), cc.p(0,1), cc.p(0 ,size.height), -5, 1, size.width)
            content_container:addChild(self.content_type3_rich_label)
        end

        --self.content_type3_rich_label:setString(event_config.word)
        self.content_type3_rich_label:setString("")

        self.content_type3:setVisible(true)

        self.content_type3_rich_label.word = event_config.word
        self.content_type3_rich_label.current_len = 0
        self.content_type3.is_working = true
        local act = cc.RepeatForever:create(cc.Sequence:create(cc.CallFunc:create(function()
            local isGoOn = self:dialogLabelAnimate(self.content_type3_rich_label)
            if not isGoOn then
                self.content_type3:stopAllActions()
                self.content_type3.is_working = false
            end
        end), cc.DelayTime:create(self.word_delay_time)))
        self.content_type3:runAction(act)
    else
        self.content_type3:setVisible(false)
    end
end
function WY_StoryWindowStage:updateContentType4(event_config)
    if event_config.diag_type == GW_StoryConst.chat_event_diag_type.screen then
        if self.content_type4_rich_label == nil then
            local content_container = self.content_type4:getChildByName("content_container")
            local size = content_container:getContentSize()
            self.content_type4_rich_label = createRichLabel(28, cc.c4b(0xfe,0xfe,0xfe,0xff), cc.p(0,1), cc.p(0 ,size.height), -5, 1, size.width)
            content_container:addChild(self.content_type4_rich_label)
        end

        --self.content_type4_rich_label:setString(event_config.word)
        self.content_type4_rich_label:setString("")
        local rich_label_size = self.content_type4_rich_label:getSize()
        self.content_type4_rich_label:setPositionY(CC_DESIGN_RESOLUTION.height/2 + rich_label_size.height/2 - 110)

        self.content_type4:setVisible(true)

        self.content_type4_rich_label.word = event_config.word
        self.content_type4_rich_label.current_len = 0
        self.content_type4.is_working = true
        local act = cc.RepeatForever:create(cc.Sequence:create(cc.CallFunc:create(function()
            local isGoOn = self:dialogLabelAnimate(self.content_type4_rich_label)
            if not isGoOn then
                self.content_type4:stopAllActions()
                self.content_type4.is_working = false
            end
        end), cc.DelayTime:create(self.word_delay_time)))
        self.content_type4:runAction(act)
    else
        self.content_type4:setVisible(false)
    end
end

----NPC进场完成
--function WY_StoryWindowStage:finishEnterNPC()
--    if self.event_config.left_npc > 0 and self.left_npc_node.isShow == true and
--            self.event_config.center_npc > 0 and self.center.isShow == true and
--            self.event_config.right_npc > 0 and self.right_npc_node.isShow == true then
--        self.next_btn:setVisible(true)
--    end
--
--end

----NPC退场完成
--function WY_StoryWindowStage:finishExitNPC()
--    --当前NPC已经全部退出
--    local effect_config = self:getCurrentEffectCoifig()
--    if self.left_npc_node.isShow == false and self.center_npc_node.isShow == false and self.right_npc_node.isShow == false then
--        self.story_effect:playingStoryEffect(effect_config)
--    end
--    if self.event_config.left_npc <= 0 and self.event_config.mid_npc <= 0 and self.event_config.right_npc <= 0 then
--        --当前没有NPC进场
--        if self.left_npc_node.isShow == false and self.center_npc_node.isShow == false and self.right_npc_node.isShow == false then
--            if not effect_config then--退场完成并且没有特效也需要显示下一步按钮
--                self.next_btn:setVisible(true)
--            end
--        end
--    else
--        --当前有NPC进场
--    end
--end

--加载角色前播放的特效
function WY_StoryWindowStage:beforeNPCUpdate(event_config)
    --Debug.log("加载角色前播放的特效 beforeNPCUpdate")
    if not event_config then
        return
    end
    local effect_config = self:getCurrentEffectCoifig()
    if effect_config then
        if GW_StoryConst.effect_playing_type.immediate == effect_config.play_time then
            --Debug.log("effect_config.play_time = " .. effect_config.play_time)
            Debug.log("加载角色前播放的特效")
            --self.story_effect:playingBGM(effect_config)
            self.story_effect:playingStoryEffect(effect_config, false)
            --self.story_effect:stopBGM()
        end
    else
        --self.next_btn:setVisible(true)
    end

    --if self.left_npc_node.isShow == false and self.center_npc_node.isShow == false and self.right_npc_node.isShow == false
    --        and self.event_config.left_npc <= 0 and self.event_config.mid_npc <= 0 and self.event_config.right_npc <= 0 then
    --    --当前场景空角色没有NPC进场和退场
    --    if not effect_config then
    --        self.next_btn:setVisible(true)
    --    end
    --else
    --end
    --
    --if effect_config and effect_config.play_time then--播放时机：退场前
    --    self.story_effect:playingStoryEffect(effect_config)
    --else--播放时机：退场后
    --    if self.left_npc_node.isShow == false and self.center_npc_node.isShow == false and self.right_npc_node.isShow == false
    --    and self.event_config.left_npc <= 0 and self.event_config.mid_npc <= 0 and self.event_config.right_npc <= 0 then
    --        --当前NPC已经全部退出,并且没有入场NPC就直接执行特效事件
    --        self.story_effect:playingStoryEffect(effect_config)
    --    end
    --end

end

----退场后前播放特效
--function WY_StoryWindowStage:afterNPCUpdate(effect_config)
--
--end

--获取特效配置
function WY_StoryWindowStage:getCurrentEffectCoifig()
    Debug.log("获取特效配置")
    local effect_config = nil
    if self.event_config and self.event_config.effect_event > 0 then
        effect_config = Config.ScriptsData.data_effect_event_fun(self.event_config.effect_event)
    end
    --Debug.info(effect_config)
    return effect_config
end

function WY_StoryWindowStage:setNextBtnVisible(isVisible)
    if isVisible then
        self.next_btn:setVisible(true)
    else
        self.next_btn:setVisible(false)
    end
end

function WY_StoryWindowStage:getEffectNode()
    return self.effect_node
end

function WY_StoryWindowStage:resetStage()
    --self.story_effect:stopAllActions()
    self.background:stopAllActions()
     self.center_npc_node:stopAllActions()
    self.right_npc_node:stopAllActions()
    self.content_type1:stopAllActions()
    self.content_type2:stopAllActions()
    self.content_type3:stopAllActions()
    self.content_type4:stopAllActions()
    --self:stopAllActions()
end

--更新对话框
function WY_StoryWindowStage:updateDialogContent(event_config)
    self:updateContentType1(event_config)
    self:updateContentType2(event_config)
    self:updateContentType3(event_config)
    self:updateContentType4(event_config)
end

--更新NPC状态
function WY_StoryWindowStage:updateNPCStatus(is_speaking_NPC, npc_node, color)
    if not npc_node then
        return
    end
    if is_speaking_NPC then
        npc_node:setColor(cc.WHITE)
        npc_node.npc_node:setLocalZOrder(2)
    else
        npc_node:setColor(self.color_grey)
        npc_node.npc_node:setLocalZOrder(1)
    end
end

--NPC退场
function WY_StoryWindowStage:performNPCExit(exit_callback)
    local is_perform_fade_out_action = false
    if self.left_npc_node.isShow then
        --淡出效果
        is_perform_fade_out_action = true
        self.left_npc_node.isShow = false
        self:updateNPCStatus(true, self.left_npc_draw)
        self.left_npc_node:stopAllActions()
        self.left_npc_node:setOpacity(255)
        local act = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
            --self.left_npc_load_finished = true
            --self:checkShowFinished(2)
            if exit_callback then
                exit_callback()
            end
        end))
        self.left_npc_node:runAction(act)
    end
    if self.center_npc_node.isShow then
        --淡出效果
        is_perform_fade_out_action = true
        self.center_npc_node.isShow = false
        self:updateNPCStatus(true, self.center_npc_draw)
        self.center_npc_node:stopAllActions()
        self.center_npc_node:setOpacity(255)
        local act = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
            --self.center_npc_load_finished = true
            --self:checkShowFinished(3)
            if exit_callback then
                exit_callback()
            end
        end))
        self.center_npc_node:runAction(act)
    end
    if self.right_npc_node.isShow then
        --淡出效果
        is_perform_fade_out_action = true
        self.right_npc_node.isShow = false
        self:updateNPCStatus(true, self.right_npc_draw)
        self.right_npc_node:stopAllActions()
        self.right_npc_node:setOpacity(255)
        local act = cc.Sequence:create(cc.FadeOut:create(self.fadeInTime), cc.CallFunc:create(function()
            --self.right_npc_load_finished = true
            --self:checkShowFinished(4)
            if exit_callback then
                exit_callback()
            end
        end))
        self.right_npc_node:runAction(act)
    end
    if not is_perform_fade_out_action then
        if exit_callback then
            exit_callback()
        end
    end
end

--NPC入场
function WY_StoryWindowStage:performNPCEnter(update_node)
    if nil == update_node then
        return
    end
    local act = cc.Sequence:create(cc.DelayTime:create(self.fadeInTime), cc.FadeIn:create(self.fadeInTime), cc.CallFunc:create(function()
        if update_node == self.left_npc_node then
            self.left_npc_load_finished = true
        elseif update_node == self.center_npc_node then
            self.center_npc_load_finished = true
        else
            self.right_npc_load_finished = true
        end
        self:checkShowFinished()
    end))
    update_node:runAction(act)
end